"use strict";

var _frisbee = _interopRequireDefault(require("frisbee"));

var _crypto = _interopRequireDefault(require("crypto"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.sourceNodes = async ({
  boundActionCreators,
  createNodeId
}, {
  accessToken,
  teamName,
  baseCategory = '',
  q = ''
}) => {
  if (!accessToken) {
    throw 'You need to set an accessToken.';
  }

  if (!teamName) {
    throw 'You need to set an teamName.';
  }

  const api = new _frisbee.default({
    baseURI: 'https://api.esa.io'
  });
  let next_page = 1;

  while (next_page) {
    const {
      body
    } = await api.jwt(accessToken).get(`/v1/teams/${teamName}/posts`, {
      body: {
        q,
        page: next_page
      }
    });
    body.posts.forEach(post => {
      const contentDigest = _crypto.default.createHash(`md5`).update(JSON.stringify(post)).digest('hex');

      boundActionCreators.createNode({ ...post,
        relative_category: post.category.replace(new RegExp(`${baseCategory}/?`), ''),
        id: createNodeId(`EsaPost${post.number}`),
        children: [],
        parent: `__SOURCE__`,
        internal: {
          type: 'EsaPost',
          contentDigest
        }
      });
    });
    next_page = body.next_page;
  }

  return;
};